/* Settings.c generated by valac 0.56.17, the Vala compiler
 * generated from Settings.vala, do not modify */

/* Settings.vala
 *
 * The following code is a derivative work of the code from
 * https://github.com/elementary/granite/blob/master/lib/Services/Settings.vala
 * which is licensed under GNU Lesser General Public version 3 of the License,
 * or (at your option) any later version.
 *
 * Copyright 2020-2022 Paulo Queiroz <pvaqueiroz@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "pqmarble.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PQ_MARBLE_SETTINGS_0_PROPERTY,
	PQ_MARBLE_SETTINGS_SCHEMA_PROPERTY,
	PQ_MARBLE_SETTINGS_NUM_PROPERTIES
};
static GParamSpec* pq_marble_settings_properties[PQ_MARBLE_SETTINGS_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _PQMarbleSettingsPrivate {
	GSettings* _schema;
	gboolean updating;
	gboolean doing_setup;
};

static gint PQMarbleSettings_private_offset;
static gpointer pq_marble_settings_parent_class = NULL;

static void pq_marble_settings_load_key (PQMarbleSettings* self,
                                  const gchar* key);
static void pq_marble_settings_on_notify (PQMarbleSettings* self,
                                   GObject* sender,
                                   GParamSpec* prop);
static void _pq_marble_settings_on_notify_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self);
static void pq_marble_settings_save_key (PQMarbleSettings* self,
                                  const gchar* key);
static GObject * pq_marble_settings_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void _pq_marble_settings_load_key_g_settings_changed (GSettings* _sender,
                                                      const gchar* key,
                                                      gpointer self);
static void pq_marble_settings_finalize (GObject * obj);
static GType pq_marble_settings_get_type_once (void);
static void _vala_pq_marble_settings_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_pq_marble_settings_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
pq_marble_settings_get_instance_private (PQMarbleSettings* self)
{
	return G_STRUCT_MEMBER_P (self, PQMarbleSettings_private_offset);
}

PQMarbleSettings*
pq_marble_settings_construct (GType object_type,
                              const gchar* path)
{
	PQMarbleSettings * self = NULL;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 32 "../src/services/Settings.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 33 "../src/services/Settings.vala"
	_tmp0_ = g_settings_new (path);
#line 33 "../src/services/Settings.vala"
	_tmp1_ = _tmp0_;
#line 33 "../src/services/Settings.vala"
	self = (PQMarbleSettings*) g_object_new (object_type, "schema", _tmp1_, NULL);
#line 33 "../src/services/Settings.vala"
	_g_object_unref0 (_tmp1_);
#line 32 "../src/services/Settings.vala"
	return self;
#line 128 "Settings.c"
}

static gpointer
_g_param_spec_ref0 (gpointer self)
{
#line 57 "../src/services/Settings.vala"
	return self ? g_param_spec_ref (self) : NULL;
#line 136 "Settings.c"
}

static void
_pq_marble_settings_on_notify_g_object_notify (GObject* _sender,
                                               GParamSpec* pspec,
                                               gpointer self)
{
#line 63 "../src/services/Settings.vala"
	pq_marble_settings_on_notify ((PQMarbleSettings*) self, _sender, pspec);
#line 146 "Settings.c"
}

static void
pq_marble_settings_load_key (PQMarbleSettings* self,
                             const gchar* key)
{
	GObjectClass* obj_class = NULL;
	GTypeClass* _tmp0_;
	GParamSpec* prop = NULL;
	GObjectClass* _tmp1_;
	GParamSpec* _tmp2_;
	GParamSpec* _tmp3_;
	GParamSpec* _tmp4_;
	guint _tmp5_;
	GType type = 0UL;
	GParamSpec* _tmp6_;
	GValue val = {0};
	GValue _tmp7_ = {0};
	GParamSpec* _tmp8_;
#line 51 "../src/services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/services/Settings.vala"
	g_return_if_fail (key != NULL);
#line 52 "../src/services/Settings.vala"
	if (g_strcmp0 (key, "schema") == 0) {
#line 53 "../src/services/Settings.vala"
		return;
#line 174 "Settings.c"
	}
#line 56 "../src/services/Settings.vala"
	_tmp0_ = g_type_class_ref (G_TYPE_FROM_INSTANCE ((GObject*) self));
#line 56 "../src/services/Settings.vala"
	obj_class = (GObjectClass*) _tmp0_;
#line 57 "../src/services/Settings.vala"
	_tmp1_ = obj_class;
#line 57 "../src/services/Settings.vala"
	_tmp2_ = g_object_class_find_property (_tmp1_, key);
#line 57 "../src/services/Settings.vala"
	_tmp3_ = _g_param_spec_ref0 (_tmp2_);
#line 57 "../src/services/Settings.vala"
	prop = _tmp3_;
#line 59 "../src/services/Settings.vala"
	_tmp4_ = prop;
#line 59 "../src/services/Settings.vala"
	if (_tmp4_ == NULL) {
#line 60 "../src/services/Settings.vala"
		_g_param_spec_unref0 (prop);
#line 60 "../src/services/Settings.vala"
		_g_type_class_unref0 (obj_class);
#line 60 "../src/services/Settings.vala"
		return;
#line 198 "Settings.c"
	}
#line 63 "../src/services/Settings.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp5_, NULL, FALSE);
#line 63 "../src/services/Settings.vala"
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _pq_marble_settings_on_notify_g_object_notify, self);
#line 65 "../src/services/Settings.vala"
	_tmp6_ = prop;
#line 65 "../src/services/Settings.vala"
	type = _tmp6_->value_type;
#line 66 "../src/services/Settings.vala"
	g_value_init (&_tmp7_, type);
#line 66 "../src/services/Settings.vala"
	val = _tmp7_;
#line 67 "../src/services/Settings.vala"
	g_object_get_property ((GObject*) self, key, &val);
#line 70 "../src/services/Settings.vala"
	_tmp8_ = prop;
#line 70 "../src/services/Settings.vala"
	if (G_VALUE_TYPE (&val) != _tmp8_->value_type) {
#line 218 "Settings.c"
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 71 "../src/services/Settings.vala"
		_tmp9_ = g_strdup_printf ("%lu", (gulong) type);
#line 71 "../src/services/Settings.vala"
		_tmp10_ = _tmp9_;
#line 71 "../src/services/Settings.vala"
		g_warning ("Settings.vala:71: Unsupported type %s for key %s", _tmp10_, key);
#line 71 "../src/services/Settings.vala"
		_g_free0 (_tmp10_);
#line 72 "../src/services/Settings.vala"
		g_signal_connect_object ((GObject*) self, "notify", (GCallback) _pq_marble_settings_on_notify_g_object_notify, self, 0);
#line 73 "../src/services/Settings.vala"
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 73 "../src/services/Settings.vala"
		_g_param_spec_unref0 (prop);
#line 73 "../src/services/Settings.vala"
		_g_type_class_unref0 (obj_class);
#line 73 "../src/services/Settings.vala"
		return;
#line 239 "Settings.c"
	}
#line 76 "../src/services/Settings.vala"
	if (type == G_TYPE_INT) {
#line 243 "Settings.c"
		GParamSpec* _tmp11_;
		const gchar* _tmp12_;
		GSettings* _tmp13_;
		GValue _tmp14_ = {0};
#line 77 "../src/services/Settings.vala"
		_tmp11_ = prop;
#line 77 "../src/services/Settings.vala"
		_tmp12_ = _tmp11_->name;
#line 77 "../src/services/Settings.vala"
		_tmp13_ = self->priv->_schema;
#line 77 "../src/services/Settings.vala"
		g_value_init (&_tmp14_, G_TYPE_INT);
#line 77 "../src/services/Settings.vala"
		g_value_set_int (&_tmp14_, g_settings_get_int (_tmp13_, key));
#line 77 "../src/services/Settings.vala"
		g_object_set_property ((GObject*) self, _tmp12_, &_tmp14_);
#line 77 "../src/services/Settings.vala"
		G_IS_VALUE (&_tmp14_) ? (g_value_unset (&_tmp14_), NULL) : NULL;
#line 262 "Settings.c"
	} else {
#line 79 "../src/services/Settings.vala"
		if (type == G_TYPE_UINT) {
#line 266 "Settings.c"
			GParamSpec* _tmp15_;
			const gchar* _tmp16_;
			GSettings* _tmp17_;
			GValue _tmp18_ = {0};
#line 80 "../src/services/Settings.vala"
			_tmp15_ = prop;
#line 80 "../src/services/Settings.vala"
			_tmp16_ = _tmp15_->name;
#line 80 "../src/services/Settings.vala"
			_tmp17_ = self->priv->_schema;
#line 80 "../src/services/Settings.vala"
			g_value_init (&_tmp18_, G_TYPE_UINT);
#line 80 "../src/services/Settings.vala"
			g_value_set_uint (&_tmp18_, g_settings_get_uint (_tmp17_, key));
#line 80 "../src/services/Settings.vala"
			g_object_set_property ((GObject*) self, _tmp16_, &_tmp18_);
#line 80 "../src/services/Settings.vala"
			G_IS_VALUE (&_tmp18_) ? (g_value_unset (&_tmp18_), NULL) : NULL;
#line 285 "Settings.c"
		} else {
#line 82 "../src/services/Settings.vala"
			if (type == G_TYPE_DOUBLE) {
#line 289 "Settings.c"
				GParamSpec* _tmp19_;
				const gchar* _tmp20_;
				GSettings* _tmp21_;
				GValue _tmp22_ = {0};
#line 83 "../src/services/Settings.vala"
				_tmp19_ = prop;
#line 83 "../src/services/Settings.vala"
				_tmp20_ = _tmp19_->name;
#line 83 "../src/services/Settings.vala"
				_tmp21_ = self->priv->_schema;
#line 83 "../src/services/Settings.vala"
				g_value_init (&_tmp22_, G_TYPE_DOUBLE);
#line 83 "../src/services/Settings.vala"
				g_value_set_double (&_tmp22_, g_settings_get_double (_tmp21_, key));
#line 83 "../src/services/Settings.vala"
				g_object_set_property ((GObject*) self, _tmp20_, &_tmp22_);
#line 83 "../src/services/Settings.vala"
				G_IS_VALUE (&_tmp22_) ? (g_value_unset (&_tmp22_), NULL) : NULL;
#line 308 "Settings.c"
			} else {
#line 85 "../src/services/Settings.vala"
				if (type == G_TYPE_BOOLEAN) {
#line 312 "Settings.c"
					GParamSpec* _tmp23_;
					const gchar* _tmp24_;
					GSettings* _tmp25_;
					GValue _tmp26_ = {0};
#line 86 "../src/services/Settings.vala"
					_tmp23_ = prop;
#line 86 "../src/services/Settings.vala"
					_tmp24_ = _tmp23_->name;
#line 86 "../src/services/Settings.vala"
					_tmp25_ = self->priv->_schema;
#line 86 "../src/services/Settings.vala"
					g_value_init (&_tmp26_, G_TYPE_BOOLEAN);
#line 86 "../src/services/Settings.vala"
					g_value_set_boolean (&_tmp26_, g_settings_get_boolean (_tmp25_, key));
#line 86 "../src/services/Settings.vala"
					g_object_set_property ((GObject*) self, _tmp24_, &_tmp26_);
#line 86 "../src/services/Settings.vala"
					G_IS_VALUE (&_tmp26_) ? (g_value_unset (&_tmp26_), NULL) : NULL;
#line 331 "Settings.c"
				} else {
#line 88 "../src/services/Settings.vala"
					if (type == G_TYPE_STRING) {
#line 335 "Settings.c"
						GParamSpec* _tmp27_;
						const gchar* _tmp28_;
						GSettings* _tmp29_;
						gchar* _tmp30_;
						GValue _tmp31_ = {0};
#line 89 "../src/services/Settings.vala"
						_tmp27_ = prop;
#line 89 "../src/services/Settings.vala"
						_tmp28_ = _tmp27_->name;
#line 89 "../src/services/Settings.vala"
						_tmp29_ = self->priv->_schema;
#line 89 "../src/services/Settings.vala"
						_tmp30_ = g_settings_get_string (_tmp29_, key);
#line 89 "../src/services/Settings.vala"
						g_value_init (&_tmp31_, G_TYPE_STRING);
#line 89 "../src/services/Settings.vala"
						g_value_take_string (&_tmp31_, _tmp30_);
#line 89 "../src/services/Settings.vala"
						g_object_set_property ((GObject*) self, _tmp28_, &_tmp31_);
#line 89 "../src/services/Settings.vala"
						G_IS_VALUE (&_tmp31_) ? (g_value_unset (&_tmp31_), NULL) : NULL;
#line 357 "Settings.c"
					} else {
#line 91 "../src/services/Settings.vala"
						if (type == G_TYPE_STRV) {
#line 361 "Settings.c"
							GParamSpec* _tmp32_;
							const gchar* _tmp33_;
							GSettings* _tmp34_;
							gchar** _tmp35_;
							gchar** _tmp36_;
							GValue _tmp37_ = {0};
#line 92 "../src/services/Settings.vala"
							_tmp32_ = prop;
#line 92 "../src/services/Settings.vala"
							_tmp33_ = _tmp32_->name;
#line 92 "../src/services/Settings.vala"
							_tmp34_ = self->priv->_schema;
#line 92 "../src/services/Settings.vala"
							_tmp36_ = _tmp35_ = g_settings_get_strv (_tmp34_, key);
#line 92 "../src/services/Settings.vala"
							g_value_init (&_tmp37_, G_TYPE_STRV);
#line 92 "../src/services/Settings.vala"
							g_value_take_boxed (&_tmp37_, _tmp36_);
#line 92 "../src/services/Settings.vala"
							g_object_set_property ((GObject*) self, _tmp33_, &_tmp37_);
#line 92 "../src/services/Settings.vala"
							G_IS_VALUE (&_tmp37_) ? (g_value_unset (&_tmp37_), NULL) : NULL;
#line 384 "Settings.c"
						} else {
#line 94 "../src/services/Settings.vala"
							if (type == G_TYPE_INT64) {
#line 388 "Settings.c"
								GParamSpec* _tmp38_;
								const gchar* _tmp39_;
								GSettings* _tmp40_;
								GVariant* _tmp41_;
								GVariant* _tmp42_;
								GValue _tmp43_ = {0};
#line 95 "../src/services/Settings.vala"
								_tmp38_ = prop;
#line 95 "../src/services/Settings.vala"
								_tmp39_ = _tmp38_->name;
#line 95 "../src/services/Settings.vala"
								_tmp40_ = self->priv->_schema;
#line 95 "../src/services/Settings.vala"
								_tmp41_ = g_settings_get_value (_tmp40_, key);
#line 95 "../src/services/Settings.vala"
								_tmp42_ = _tmp41_;
#line 95 "../src/services/Settings.vala"
								g_value_init (&_tmp43_, G_TYPE_INT64);
#line 95 "../src/services/Settings.vala"
								g_value_set_int64 (&_tmp43_, g_variant_get_int64 (_tmp42_));
#line 95 "../src/services/Settings.vala"
								g_object_set_property ((GObject*) self, _tmp39_, &_tmp43_);
#line 95 "../src/services/Settings.vala"
								G_IS_VALUE (&_tmp43_) ? (g_value_unset (&_tmp43_), NULL) : NULL;
#line 95 "../src/services/Settings.vala"
								_g_variant_unref0 (_tmp42_);
#line 415 "Settings.c"
							} else {
#line 97 "../src/services/Settings.vala"
								if (type == G_TYPE_UINT64) {
#line 419 "Settings.c"
									GParamSpec* _tmp44_;
									const gchar* _tmp45_;
									GSettings* _tmp46_;
									GVariant* _tmp47_;
									GVariant* _tmp48_;
									GValue _tmp49_ = {0};
#line 98 "../src/services/Settings.vala"
									_tmp44_ = prop;
#line 98 "../src/services/Settings.vala"
									_tmp45_ = _tmp44_->name;
#line 98 "../src/services/Settings.vala"
									_tmp46_ = self->priv->_schema;
#line 98 "../src/services/Settings.vala"
									_tmp47_ = g_settings_get_value (_tmp46_, key);
#line 98 "../src/services/Settings.vala"
									_tmp48_ = _tmp47_;
#line 98 "../src/services/Settings.vala"
									g_value_init (&_tmp49_, G_TYPE_UINT64);
#line 98 "../src/services/Settings.vala"
									g_value_set_uint64 (&_tmp49_, g_variant_get_uint64 (_tmp48_));
#line 98 "../src/services/Settings.vala"
									g_object_set_property ((GObject*) self, _tmp45_, &_tmp49_);
#line 98 "../src/services/Settings.vala"
									G_IS_VALUE (&_tmp49_) ? (g_value_unset (&_tmp49_), NULL) : NULL;
#line 98 "../src/services/Settings.vala"
									_g_variant_unref0 (_tmp48_);
#line 446 "Settings.c"
								} else {
#line 103 "../src/services/Settings.vala"
									if (G_TYPE_IS_ENUM (type)) {
#line 450 "Settings.c"
										GParamSpec* _tmp50_;
										const gchar* _tmp51_;
										GSettings* _tmp52_;
										GValue _tmp53_ = {0};
#line 104 "../src/services/Settings.vala"
										_tmp50_ = prop;
#line 104 "../src/services/Settings.vala"
										_tmp51_ = _tmp50_->name;
#line 104 "../src/services/Settings.vala"
										_tmp52_ = self->priv->_schema;
#line 104 "../src/services/Settings.vala"
										g_value_init (&_tmp53_, G_TYPE_INT);
#line 104 "../src/services/Settings.vala"
										g_value_set_int (&_tmp53_, g_settings_get_enum (_tmp52_, key));
#line 104 "../src/services/Settings.vala"
										g_object_set_property ((GObject*) self, _tmp51_, &_tmp53_);
#line 104 "../src/services/Settings.vala"
										G_IS_VALUE (&_tmp53_) ? (g_value_unset (&_tmp53_), NULL) : NULL;
#line 469 "Settings.c"
									} else {
#line 106 "../src/services/Settings.vala"
										if (type == G_TYPE_VARIANT) {
#line 473 "Settings.c"
											GParamSpec* _tmp54_;
											const gchar* _tmp55_;
											GSettings* _tmp56_;
											GVariant* _tmp57_;
											GValue _tmp58_ = {0};
#line 107 "../src/services/Settings.vala"
											_tmp54_ = prop;
#line 107 "../src/services/Settings.vala"
											_tmp55_ = _tmp54_->name;
#line 107 "../src/services/Settings.vala"
											_tmp56_ = self->priv->_schema;
#line 107 "../src/services/Settings.vala"
											_tmp57_ = g_settings_get_value (_tmp56_, key);
#line 107 "../src/services/Settings.vala"
											g_value_init (&_tmp58_, G_TYPE_VARIANT);
#line 107 "../src/services/Settings.vala"
											g_value_take_variant (&_tmp58_, _tmp57_);
#line 107 "../src/services/Settings.vala"
											g_object_set_property ((GObject*) self, _tmp55_, &_tmp58_);
#line 107 "../src/services/Settings.vala"
											G_IS_VALUE (&_tmp58_) ? (g_value_unset (&_tmp58_), NULL) : NULL;
#line 495 "Settings.c"
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 110 "../src/services/Settings.vala"
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _pq_marble_settings_on_notify_g_object_notify, self, 0);
#line 51 "../src/services/Settings.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 51 "../src/services/Settings.vala"
	_g_param_spec_unref0 (prop);
#line 51 "../src/services/Settings.vala"
	_g_type_class_unref0 (obj_class);
#line 514 "Settings.c"
}

static void
pq_marble_settings_save_key (PQMarbleSettings* self,
                             const gchar* key)
{
	gboolean _tmp0_ = FALSE;
	GObjectClass* obj_class = NULL;
	GTypeClass* _tmp1_;
	GParamSpec* prop = NULL;
	GObjectClass* _tmp2_;
	GParamSpec* _tmp3_;
	GParamSpec* _tmp4_;
	GParamSpec* _tmp5_;
	guint _tmp6_;
	gboolean res = FALSE;
	GType type = 0UL;
	GParamSpec* _tmp7_;
	GValue val = {0};
	GValue _tmp8_ = {0};
	GParamSpec* _tmp9_;
	const gchar* _tmp10_;
	GParamSpec* _tmp11_;
	gboolean _tmp14_ = FALSE;
#line 113 "../src/services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 113 "../src/services/Settings.vala"
	g_return_if_fail (key != NULL);
#line 114 "../src/services/Settings.vala"
	if (g_strcmp0 (key, "schema") == 0) {
#line 114 "../src/services/Settings.vala"
		_tmp0_ = TRUE;
#line 547 "Settings.c"
	} else {
#line 114 "../src/services/Settings.vala"
		_tmp0_ = self->priv->updating;
#line 551 "Settings.c"
	}
#line 114 "../src/services/Settings.vala"
	if (_tmp0_) {
#line 115 "../src/services/Settings.vala"
		return;
#line 557 "Settings.c"
	}
#line 118 "../src/services/Settings.vala"
	_tmp1_ = g_type_class_ref (G_TYPE_FROM_INSTANCE ((GObject*) self));
#line 118 "../src/services/Settings.vala"
	obj_class = (GObjectClass*) _tmp1_;
#line 119 "../src/services/Settings.vala"
	_tmp2_ = obj_class;
#line 119 "../src/services/Settings.vala"
	_tmp3_ = g_object_class_find_property (_tmp2_, key);
#line 119 "../src/services/Settings.vala"
	_tmp4_ = _g_param_spec_ref0 (_tmp3_);
#line 119 "../src/services/Settings.vala"
	prop = _tmp4_;
#line 121 "../src/services/Settings.vala"
	_tmp5_ = prop;
#line 121 "../src/services/Settings.vala"
	if (_tmp5_ == NULL) {
#line 122 "../src/services/Settings.vala"
		_g_param_spec_unref0 (prop);
#line 122 "../src/services/Settings.vala"
		_g_type_class_unref0 (obj_class);
#line 122 "../src/services/Settings.vala"
		return;
#line 581 "Settings.c"
	}
#line 125 "../src/services/Settings.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp6_, NULL, FALSE);
#line 125 "../src/services/Settings.vala"
	g_signal_handlers_disconnect_matched ((GObject*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _pq_marble_settings_on_notify_g_object_notify, self);
#line 127 "../src/services/Settings.vala"
	res = TRUE;
#line 128 "../src/services/Settings.vala"
	self->priv->updating = TRUE;
#line 130 "../src/services/Settings.vala"
	_tmp7_ = prop;
#line 130 "../src/services/Settings.vala"
	type = _tmp7_->value_type;
#line 131 "../src/services/Settings.vala"
	g_value_init (&_tmp8_, type);
#line 131 "../src/services/Settings.vala"
	val = _tmp8_;
#line 132 "../src/services/Settings.vala"
	_tmp9_ = prop;
#line 132 "../src/services/Settings.vala"
	_tmp10_ = _tmp9_->name;
#line 132 "../src/services/Settings.vala"
	g_object_get_property ((GObject*) self, _tmp10_, &val);
#line 135 "../src/services/Settings.vala"
	_tmp11_ = prop;
#line 135 "../src/services/Settings.vala"
	if (G_VALUE_TYPE (&val) != _tmp11_->value_type) {
#line 609 "Settings.c"
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 136 "../src/services/Settings.vala"
		_tmp12_ = g_strdup_printf ("%lu", (gulong) type);
#line 136 "../src/services/Settings.vala"
		_tmp13_ = _tmp12_;
#line 136 "../src/services/Settings.vala"
		g_warning ("Settings.vala:136: Unsupported type %s for key %s", _tmp13_, key);
#line 136 "../src/services/Settings.vala"
		_g_free0 (_tmp13_);
#line 620 "Settings.c"
	}
#line 140 "../src/services/Settings.vala"
	if (type == G_TYPE_INT) {
#line 624 "Settings.c"
		GSettings* _tmp15_;
#line 140 "../src/services/Settings.vala"
		_tmp15_ = self->priv->_schema;
#line 140 "../src/services/Settings.vala"
		_tmp14_ = g_value_get_int (&val) != g_settings_get_int (_tmp15_, key);
#line 630 "Settings.c"
	} else {
#line 140 "../src/services/Settings.vala"
		_tmp14_ = FALSE;
#line 634 "Settings.c"
	}
#line 139 "../src/services/Settings.vala"
	if (_tmp14_) {
#line 638 "Settings.c"
		GSettings* _tmp16_;
#line 142 "../src/services/Settings.vala"
		_tmp16_ = self->priv->_schema;
#line 142 "../src/services/Settings.vala"
		res = g_settings_set_int (_tmp16_, key, g_value_get_int (&val));
#line 644 "Settings.c"
	} else {
		gboolean _tmp17_ = FALSE;
#line 145 "../src/services/Settings.vala"
		if (type == G_TYPE_UINT) {
#line 649 "Settings.c"
			GSettings* _tmp18_;
#line 145 "../src/services/Settings.vala"
			_tmp18_ = self->priv->_schema;
#line 145 "../src/services/Settings.vala"
			_tmp17_ = g_value_get_uint (&val) != g_settings_get_uint (_tmp18_, key);
#line 655 "Settings.c"
		} else {
#line 145 "../src/services/Settings.vala"
			_tmp17_ = FALSE;
#line 659 "Settings.c"
		}
#line 144 "../src/services/Settings.vala"
		if (_tmp17_) {
#line 663 "Settings.c"
			GSettings* _tmp19_;
#line 147 "../src/services/Settings.vala"
			_tmp19_ = self->priv->_schema;
#line 147 "../src/services/Settings.vala"
			res = g_settings_set_uint (_tmp19_, key, g_value_get_uint (&val));
#line 669 "Settings.c"
		} else {
			gboolean _tmp20_ = FALSE;
#line 150 "../src/services/Settings.vala"
			if (type == G_TYPE_DOUBLE) {
#line 674 "Settings.c"
				GSettings* _tmp21_;
#line 151 "../src/services/Settings.vala"
				_tmp21_ = self->priv->_schema;
#line 151 "../src/services/Settings.vala"
				_tmp20_ = g_value_get_double (&val) != g_settings_get_double (_tmp21_, key);
#line 680 "Settings.c"
			} else {
#line 150 "../src/services/Settings.vala"
				_tmp20_ = FALSE;
#line 684 "Settings.c"
			}
#line 149 "../src/services/Settings.vala"
			if (_tmp20_) {
#line 688 "Settings.c"
				GSettings* _tmp22_;
#line 153 "../src/services/Settings.vala"
				_tmp22_ = self->priv->_schema;
#line 153 "../src/services/Settings.vala"
				res = g_settings_set_double (_tmp22_, key, g_value_get_double (&val));
#line 694 "Settings.c"
			} else {
				gboolean _tmp23_ = FALSE;
#line 156 "../src/services/Settings.vala"
				if (type == G_TYPE_BOOLEAN) {
#line 699 "Settings.c"
					GSettings* _tmp24_;
#line 157 "../src/services/Settings.vala"
					_tmp24_ = self->priv->_schema;
#line 157 "../src/services/Settings.vala"
					_tmp23_ = g_value_get_boolean (&val) != g_settings_get_boolean (_tmp24_, key);
#line 705 "Settings.c"
				} else {
#line 156 "../src/services/Settings.vala"
					_tmp23_ = FALSE;
#line 709 "Settings.c"
				}
#line 155 "../src/services/Settings.vala"
				if (_tmp23_) {
#line 713 "Settings.c"
					GSettings* _tmp25_;
#line 159 "../src/services/Settings.vala"
					_tmp25_ = self->priv->_schema;
#line 159 "../src/services/Settings.vala"
					res = g_settings_set_boolean (_tmp25_, key, g_value_get_boolean (&val));
#line 719 "Settings.c"
				} else {
					gboolean _tmp26_ = FALSE;
#line 162 "../src/services/Settings.vala"
					if (type == G_TYPE_STRING) {
#line 724 "Settings.c"
						const gchar* _tmp27_;
						GSettings* _tmp28_;
						gchar* _tmp29_;
						gchar* _tmp30_;
#line 163 "../src/services/Settings.vala"
						_tmp27_ = g_value_get_string (&val);
#line 163 "../src/services/Settings.vala"
						_tmp28_ = self->priv->_schema;
#line 163 "../src/services/Settings.vala"
						_tmp29_ = g_settings_get_string (_tmp28_, key);
#line 163 "../src/services/Settings.vala"
						_tmp30_ = _tmp29_;
#line 163 "../src/services/Settings.vala"
						_tmp26_ = g_strcmp0 (_tmp27_, _tmp30_) != 0;
#line 163 "../src/services/Settings.vala"
						_g_free0 (_tmp30_);
#line 741 "Settings.c"
					} else {
#line 162 "../src/services/Settings.vala"
						_tmp26_ = FALSE;
#line 745 "Settings.c"
					}
#line 161 "../src/services/Settings.vala"
					if (_tmp26_) {
#line 749 "Settings.c"
						GSettings* _tmp31_;
						const gchar* _tmp32_;
#line 165 "../src/services/Settings.vala"
						_tmp31_ = self->priv->_schema;
#line 165 "../src/services/Settings.vala"
						_tmp32_ = g_value_get_string (&val);
#line 165 "../src/services/Settings.vala"
						res = g_settings_set_string (_tmp31_, key, _tmp32_);
#line 758 "Settings.c"
					} else {
#line 167 "../src/services/Settings.vala"
						if (type == G_TYPE_STRV) {
#line 762 "Settings.c"
							gchar** strv = NULL;
							gint strv_length1;
							gint _strv_size_;
							gchar** _tmp33_;
							gint _tmp33__length1;
							GSettings* _tmp34_;
							gchar** _tmp35_;
							gchar** _tmp36_;
							gchar** _tmp37_;
							gint _tmp37__length1;
							gboolean _tmp38_;
#line 168 "../src/services/Settings.vala"
							strv = NULL;
#line 168 "../src/services/Settings.vala"
							strv_length1 = 0;
#line 168 "../src/services/Settings.vala"
							_strv_size_ = strv_length1;
#line 169 "../src/services/Settings.vala"
							g_object_get ((GObject*) self, key, &strv, NULL);
#line 170 "../src/services/Settings.vala"
							_tmp33_ = strv;
#line 170 "../src/services/Settings.vala"
							_tmp33__length1 = strv_length1;
#line 170 "../src/services/Settings.vala"
							_tmp34_ = self->priv->_schema;
#line 170 "../src/services/Settings.vala"
							_tmp36_ = _tmp35_ = g_settings_get_strv (_tmp34_, key);
#line 170 "../src/services/Settings.vala"
							_tmp37_ = _tmp36_;
#line 170 "../src/services/Settings.vala"
							_tmp37__length1 = _vala_array_length (_tmp35_);
#line 170 "../src/services/Settings.vala"
							_tmp38_ = _tmp33_ != _tmp37_;
#line 170 "../src/services/Settings.vala"
							_tmp37_ = (_vala_array_free (_tmp37_, _tmp37__length1, (GDestroyNotify) g_free), NULL);
#line 170 "../src/services/Settings.vala"
							if (_tmp38_) {
#line 800 "Settings.c"
								GSettings* _tmp39_;
								gchar** _tmp40_;
								gint _tmp40__length1;
#line 171 "../src/services/Settings.vala"
								_tmp39_ = self->priv->_schema;
#line 171 "../src/services/Settings.vala"
								_tmp40_ = strv;
#line 171 "../src/services/Settings.vala"
								_tmp40__length1 = strv_length1;
#line 171 "../src/services/Settings.vala"
								res = g_settings_set_strv (_tmp39_, key, _tmp40_);
#line 812 "Settings.c"
							}
#line 167 "../src/services/Settings.vala"
							strv = (_vala_array_free (strv, strv_length1, (GDestroyNotify) g_free), NULL);
#line 816 "Settings.c"
						} else {
							gboolean _tmp41_ = FALSE;
#line 175 "../src/services/Settings.vala"
							if (type == G_TYPE_INT64) {
#line 821 "Settings.c"
								GSettings* _tmp42_;
								GVariant* _tmp43_;
								GVariant* _tmp44_;
#line 176 "../src/services/Settings.vala"
								_tmp42_ = self->priv->_schema;
#line 176 "../src/services/Settings.vala"
								_tmp43_ = g_settings_get_value (_tmp42_, key);
#line 176 "../src/services/Settings.vala"
								_tmp44_ = _tmp43_;
#line 176 "../src/services/Settings.vala"
								_tmp41_ = g_value_get_int64 (&val) != g_variant_get_int64 (_tmp44_);
#line 176 "../src/services/Settings.vala"
								_g_variant_unref0 (_tmp44_);
#line 835 "Settings.c"
							} else {
#line 175 "../src/services/Settings.vala"
								_tmp41_ = FALSE;
#line 839 "Settings.c"
							}
#line 174 "../src/services/Settings.vala"
							if (_tmp41_) {
#line 843 "Settings.c"
								GSettings* _tmp45_;
								GVariant* _tmp46_;
								GVariant* _tmp47_;
#line 178 "../src/services/Settings.vala"
								_tmp45_ = self->priv->_schema;
#line 178 "../src/services/Settings.vala"
								_tmp46_ = g_variant_new_int64 (g_value_get_int64 (&val));
#line 178 "../src/services/Settings.vala"
								g_variant_ref_sink (_tmp46_);
#line 178 "../src/services/Settings.vala"
								_tmp47_ = _tmp46_;
#line 178 "../src/services/Settings.vala"
								res = g_settings_set_value (_tmp45_, key, _tmp47_);
#line 178 "../src/services/Settings.vala"
								_g_variant_unref0 (_tmp47_);
#line 859 "Settings.c"
							} else {
								gboolean _tmp48_ = FALSE;
#line 184 "../src/services/Settings.vala"
								if (type == G_TYPE_UINT64) {
#line 864 "Settings.c"
									GSettings* _tmp49_;
									GVariant* _tmp50_;
									GVariant* _tmp51_;
#line 185 "../src/services/Settings.vala"
									_tmp49_ = self->priv->_schema;
#line 185 "../src/services/Settings.vala"
									_tmp50_ = g_settings_get_value (_tmp49_, key);
#line 185 "../src/services/Settings.vala"
									_tmp51_ = _tmp50_;
#line 185 "../src/services/Settings.vala"
									_tmp48_ = g_value_get_uint64 (&val) != g_variant_get_uint64 (_tmp51_);
#line 185 "../src/services/Settings.vala"
									_g_variant_unref0 (_tmp51_);
#line 878 "Settings.c"
								} else {
#line 184 "../src/services/Settings.vala"
									_tmp48_ = FALSE;
#line 882 "Settings.c"
								}
#line 183 "../src/services/Settings.vala"
								if (_tmp48_) {
#line 886 "Settings.c"
									GSettings* _tmp52_;
									GVariant* _tmp53_;
									GVariant* _tmp54_;
#line 187 "../src/services/Settings.vala"
									_tmp52_ = self->priv->_schema;
#line 187 "../src/services/Settings.vala"
									_tmp53_ = g_variant_new_uint64 (g_value_get_uint64 (&val));
#line 187 "../src/services/Settings.vala"
									g_variant_ref_sink (_tmp53_);
#line 187 "../src/services/Settings.vala"
									_tmp54_ = _tmp53_;
#line 187 "../src/services/Settings.vala"
									res = g_settings_set_value (_tmp52_, key, _tmp54_);
#line 187 "../src/services/Settings.vala"
									_g_variant_unref0 (_tmp54_);
#line 902 "Settings.c"
								} else {
									gboolean _tmp55_ = FALSE;
#line 193 "../src/services/Settings.vala"
									if (G_TYPE_IS_ENUM (type)) {
#line 907 "Settings.c"
										GSettings* _tmp56_;
#line 193 "../src/services/Settings.vala"
										_tmp56_ = self->priv->_schema;
#line 193 "../src/services/Settings.vala"
										_tmp55_ = g_value_get_enum (&val) != g_settings_get_enum (_tmp56_, key);
#line 913 "Settings.c"
									} else {
#line 193 "../src/services/Settings.vala"
										_tmp55_ = FALSE;
#line 917 "Settings.c"
									}
#line 192 "../src/services/Settings.vala"
									if (_tmp55_) {
#line 921 "Settings.c"
										GSettings* _tmp57_;
#line 195 "../src/services/Settings.vala"
										_tmp57_ = self->priv->_schema;
#line 195 "../src/services/Settings.vala"
										res = g_settings_set_enum (_tmp57_, key, g_value_get_enum (&val));
#line 927 "Settings.c"
									} else {
#line 197 "../src/services/Settings.vala"
										if (type == G_TYPE_VARIANT) {
#line 931 "Settings.c"
											GSettings* _tmp58_;
											GVariant* _tmp59_;
											GVariant* _tmp60_;
#line 198 "../src/services/Settings.vala"
											_tmp58_ = self->priv->_schema;
#line 198 "../src/services/Settings.vala"
											_tmp59_ = g_value_get_variant (&val);
#line 198 "../src/services/Settings.vala"
											_tmp60_ = _tmp59_;
#line 198 "../src/services/Settings.vala"
											res = g_settings_set_value (_tmp58_, key, _tmp60_);
#line 198 "../src/services/Settings.vala"
											_g_variant_unref0 (_tmp60_);
#line 945 "Settings.c"
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 201 "../src/services/Settings.vala"
	if (!res) {
#line 202 "../src/services/Settings.vala"
		g_warning ("Settings.vala:202: Could not update %s", key);
#line 960 "Settings.c"
	}
#line 205 "../src/services/Settings.vala"
	self->priv->updating = FALSE;
#line 206 "../src/services/Settings.vala"
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) _pq_marble_settings_on_notify_g_object_notify, self, 0);
#line 113 "../src/services/Settings.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 113 "../src/services/Settings.vala"
	_g_param_spec_unref0 (prop);
#line 113 "../src/services/Settings.vala"
	_g_type_class_unref0 (obj_class);
#line 972 "Settings.c"
}

static void
pq_marble_settings_on_notify (PQMarbleSettings* self,
                              GObject* sender,
                              GParamSpec* prop)
{
	const gchar* _tmp0_;
#line 209 "../src/services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 209 "../src/services/Settings.vala"
	g_return_if_fail (sender != NULL);
#line 209 "../src/services/Settings.vala"
	g_return_if_fail (prop != NULL);
#line 210 "../src/services/Settings.vala"
	_tmp0_ = prop->name;
#line 210 "../src/services/Settings.vala"
	pq_marble_settings_save_key (self, _tmp0_);
#line 991 "Settings.c"
}

GSettings*
pq_marble_settings_get_schema (PQMarbleSettings* self)
{
	GSettings* result;
	GSettings* _tmp0_;
#line 27 "../src/services/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/services/Settings.vala"
	_tmp0_ = self->priv->_schema;
#line 27 "../src/services/Settings.vala"
	result = _tmp0_;
#line 27 "../src/services/Settings.vala"
	return result;
#line 1007 "Settings.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 27 "../src/services/Settings.vala"
	return self ? g_object_ref (self) : NULL;
#line 1015 "Settings.c"
}

void
pq_marble_settings_set_schema (PQMarbleSettings* self,
                               GSettings* value)
{
	GSettings* old_value;
#line 27 "../src/services/Settings.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/services/Settings.vala"
	old_value = pq_marble_settings_get_schema (self);
#line 27 "../src/services/Settings.vala"
	if (old_value != value) {
#line 1029 "Settings.c"
		GSettings* _tmp0_;
#line 27 "../src/services/Settings.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 27 "../src/services/Settings.vala"
		_g_object_unref0 (self->priv->_schema);
#line 27 "../src/services/Settings.vala"
		self->priv->_schema = _tmp0_;
#line 27 "../src/services/Settings.vala"
		g_object_notify_by_pspec ((GObject *) self, pq_marble_settings_properties[PQ_MARBLE_SETTINGS_SCHEMA_PROPERTY]);
#line 1039 "Settings.c"
	}
}

static void
_pq_marble_settings_load_key_g_settings_changed (GSettings* _sender,
                                                 const gchar* key,
                                                 gpointer self)
{
#line 48 "../src/services/Settings.vala"
	pq_marble_settings_load_key ((PQMarbleSettings*) self, key);
#line 1050 "Settings.c"
}

static GObject *
pq_marble_settings_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PQMarbleSettings * self;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GObjectClass* obj_class = NULL;
	GTypeClass* _tmp4_;
	GParamSpec** properties = NULL;
	GObjectClass* _tmp5_;
	guint _tmp6_ = 0;
	GParamSpec** _tmp7_;
	gint properties_length1;
	gint _properties_size_;
	GParamSpec** _tmp8_;
	gint _tmp8__length1;
	GSettings* _tmp11_;
#line 37 "../src/services/Settings.vala"
	parent_class = G_OBJECT_CLASS (pq_marble_settings_parent_class);
#line 37 "../src/services/Settings.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../src/services/Settings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PQ_MARBLE_TYPE_SETTINGS, PQMarbleSettings);
#line 38 "../src/services/Settings.vala"
	_tmp0_ = self->priv->_schema;
#line 38 "../src/services/Settings.vala"
	g_object_get (_tmp0_, "schema-id", &_tmp1_, NULL);
#line 38 "../src/services/Settings.vala"
	_tmp2_ = _tmp1_;
#line 38 "../src/services/Settings.vala"
	_tmp3_ = _tmp2_;
#line 38 "../src/services/Settings.vala"
	g_debug ("Settings.vala:38: Started settings from '%s'", _tmp3_);
#line 38 "../src/services/Settings.vala"
	_g_free0 (_tmp3_);
#line 40 "../src/services/Settings.vala"
	_tmp4_ = g_type_class_ref (G_TYPE_FROM_INSTANCE ((GObject*) self));
#line 40 "../src/services/Settings.vala"
	obj_class = (GObjectClass*) _tmp4_;
#line 41 "../src/services/Settings.vala"
	_tmp5_ = obj_class;
#line 41 "../src/services/Settings.vala"
	_tmp7_ = g_object_class_list_properties (_tmp5_, &_tmp6_);
#line 41 "../src/services/Settings.vala"
	properties = _tmp7_;
#line 41 "../src/services/Settings.vala"
	properties_length1 = _tmp6_;
#line 41 "../src/services/Settings.vala"
	_properties_size_ = properties_length1;
#line 43 "../src/services/Settings.vala"
	_tmp8_ = properties;
#line 43 "../src/services/Settings.vala"
	_tmp8__length1 = properties_length1;
#line 1112 "Settings.c"
	{
		GParamSpec** prop_collection = NULL;
		gint prop_collection_length1 = 0;
		gint _prop_collection_size_ = 0;
		gint prop_it = 0;
#line 43 "../src/services/Settings.vala"
		prop_collection = _tmp8_;
#line 43 "../src/services/Settings.vala"
		prop_collection_length1 = _tmp8__length1;
#line 43 "../src/services/Settings.vala"
		for (prop_it = 0; prop_it < prop_collection_length1; prop_it = prop_it + 1) {
#line 1124 "Settings.c"
			GParamSpec* prop = NULL;
#line 43 "../src/services/Settings.vala"
			prop = prop_collection[prop_it];
#line 1128 "Settings.c"
			{
				GParamSpec* _tmp9_;
				const gchar* _tmp10_;
#line 44 "../src/services/Settings.vala"
				_tmp9_ = prop;
#line 44 "../src/services/Settings.vala"
				_tmp10_ = _tmp9_->name;
#line 44 "../src/services/Settings.vala"
				pq_marble_settings_load_key (self, _tmp10_);
#line 1138 "Settings.c"
			}
		}
	}
#line 47 "../src/services/Settings.vala"
	self->priv->doing_setup = FALSE;
#line 48 "../src/services/Settings.vala"
	_tmp11_ = self->priv->_schema;
#line 48 "../src/services/Settings.vala"
	g_signal_connect_object (_tmp11_, "changed", (GCallback) _pq_marble_settings_load_key_g_settings_changed, self, 0);
#line 37 "../src/services/Settings.vala"
	properties = (g_free (properties), NULL);
#line 37 "../src/services/Settings.vala"
	_g_type_class_unref0 (obj_class);
#line 37 "../src/services/Settings.vala"
	return obj;
#line 1154 "Settings.c"
}

static void
pq_marble_settings_class_init (PQMarbleSettingsClass * klass,
                               gpointer klass_data)
{
#line 26 "../src/services/Settings.vala"
	pq_marble_settings_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/services/Settings.vala"
	g_type_class_adjust_private_offset (klass, &PQMarbleSettings_private_offset);
#line 26 "../src/services/Settings.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_pq_marble_settings_get_property;
#line 26 "../src/services/Settings.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_pq_marble_settings_set_property;
#line 26 "../src/services/Settings.vala"
	G_OBJECT_CLASS (klass)->constructor = pq_marble_settings_constructor;
#line 26 "../src/services/Settings.vala"
	G_OBJECT_CLASS (klass)->finalize = pq_marble_settings_finalize;
#line 26 "../src/services/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PQ_MARBLE_SETTINGS_SCHEMA_PROPERTY, pq_marble_settings_properties[PQ_MARBLE_SETTINGS_SCHEMA_PROPERTY] = g_param_spec_object ("schema", "schema", "schema", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1175 "Settings.c"
}

static void
pq_marble_settings_instance_init (PQMarbleSettings * self,
                                  gpointer klass)
{
#line 26 "../src/services/Settings.vala"
	self->priv = pq_marble_settings_get_instance_private (self);
#line 29 "../src/services/Settings.vala"
	self->priv->updating = FALSE;
#line 30 "../src/services/Settings.vala"
	self->priv->doing_setup = TRUE;
#line 1188 "Settings.c"
}

static void
pq_marble_settings_finalize (GObject * obj)
{
	PQMarbleSettings * self;
#line 26 "../src/services/Settings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PQ_MARBLE_TYPE_SETTINGS, PQMarbleSettings);
#line 27 "../src/services/Settings.vala"
	_g_object_unref0 (self->priv->_schema);
#line 26 "../src/services/Settings.vala"
	G_OBJECT_CLASS (pq_marble_settings_parent_class)->finalize (obj);
#line 1201 "Settings.c"
}

static GType
pq_marble_settings_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PQMarbleSettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pq_marble_settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PQMarbleSettings), 0, (GInstanceInitFunc) pq_marble_settings_instance_init, NULL };
	GType pq_marble_settings_type_id;
	pq_marble_settings_type_id = g_type_register_static (G_TYPE_OBJECT, "PQMarbleSettings", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	PQMarbleSettings_private_offset = g_type_add_instance_private (pq_marble_settings_type_id, sizeof (PQMarbleSettingsPrivate));
	return pq_marble_settings_type_id;
}

GType
pq_marble_settings_get_type (void)
{
	static volatile gsize pq_marble_settings_type_id__once = 0;
	if (g_once_init_enter (&pq_marble_settings_type_id__once)) {
		GType pq_marble_settings_type_id;
		pq_marble_settings_type_id = pq_marble_settings_get_type_once ();
		g_once_init_leave (&pq_marble_settings_type_id__once, pq_marble_settings_type_id);
	}
	return pq_marble_settings_type_id__once;
}

static void
_vala_pq_marble_settings_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	PQMarbleSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PQ_MARBLE_TYPE_SETTINGS, PQMarbleSettings);
#line 26 "../src/services/Settings.vala"
	switch (property_id) {
#line 26 "../src/services/Settings.vala"
		case PQ_MARBLE_SETTINGS_SCHEMA_PROPERTY:
#line 26 "../src/services/Settings.vala"
		g_value_set_object (value, pq_marble_settings_get_schema (self));
#line 26 "../src/services/Settings.vala"
		break;
#line 1242 "Settings.c"
		default:
#line 26 "../src/services/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/services/Settings.vala"
		break;
#line 1248 "Settings.c"
	}
}

static void
_vala_pq_marble_settings_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	PQMarbleSettings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PQ_MARBLE_TYPE_SETTINGS, PQMarbleSettings);
#line 26 "../src/services/Settings.vala"
	switch (property_id) {
#line 26 "../src/services/Settings.vala"
		case PQ_MARBLE_SETTINGS_SCHEMA_PROPERTY:
#line 26 "../src/services/Settings.vala"
		pq_marble_settings_set_schema (self, g_value_get_object (value));
#line 26 "../src/services/Settings.vala"
		break;
#line 1268 "Settings.c"
		default:
#line 26 "../src/services/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/services/Settings.vala"
		break;
#line 1274 "Settings.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

